lttng-tools: Archive build artifacts for dev jobs
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
5a196804 1#!/bin/bash -exu
f3d8604b 2#
5a196804 3# Copyright (C) 2016-2018 - Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
39961776
MJ
18# Parameters
19arch=${arch:-}
20cross_arch=${cross_arch:-}
21ktag=${ktag:-}
5a196804
MJ
22kgitrepo=${kgitrepo:-}
23mversion=${mversion:-}
24mgitrepo=${mgitrepo:-}
39961776
MJ
25
26
339db64d
MJ
27## FUNCTIONS ##
28
f3d8604b
MJ
29# Kernel version compare functions
30verlte() {
51fa2ab3 31 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
32}
33
34verlt() {
51fa2ab3 35 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
36}
37
38vergte() {
51fa2ab3 39 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
40}
41
42vergt() {
51fa2ab3 43 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
44}
45
339db64d 46
5a196804
MJ
47git_clone_modules_sources() {
48 mkdir -p "$MODULES_GIT_DIR"
49 git clone --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
50}
51
52# Checkout a shallow kernel tree of the specified tag
53git_clone_linux_sources() {
54 mkdir -p "$LINUX_GIT_DIR"
55 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
56}
7e02032c 57
7e02032c 58
5a196804
MJ
59# Export the kernel sources from the git repo
60git_export_linux_sources() {
61 cd "$LINUX_GIT_DIR"
62 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
63}
64
65
66# Upload the tar archive to the object store
67upload_archive_obj() {
68 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
69 rm -f "$WORKSPACE/$obj_name"
70}
71
72
73extract_archive_obj() {
74 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
75 rm -f "$WORKSPACE/$obj_name"
76}
77
78
79tar_archive_obj() {
80 cd "$LINUX_OBJ_DIR"
81 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
82 cd -
83}
84
85# Find the most recent GCC version supported by the kernel sources
86select_compiler() {
87 local selected_cc
88
89 cd "$LINUX_SRCOBJ_DIR"
90
91 kversion=$(make -s kernelversion)
92
93 set +e
94
23db2292 95 for cc in gcc-7 gcc-5 gcc-4.8; do
5a196804
MJ
96 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
97 selected_cc="$cc"
98 break
99 fi
100 done
101
102 set -e
103
104 if [ "x$selected_cc" = "x" ]; then
105 echo "Found no suitable compiler."
106 exit 1
107 fi
108
109 # Force gcc-4 for buggy kernel branches
110 if { vergte "$kversion" "3.2" && verlt "$kversion" "3.3"; } || \
111 { vergte "$kversion" "3.4" && verlt "$kversion" "3.5"; } || \
112 { vergte "$kversion" "3.17" && verlt "$kversion" "3.18"; }; then
23db2292 113 selected_cc=gcc-4.8
7e02032c
MJ
114 fi
115
5a196804
MJ
116 case "$ktag" in
117 Ubuntu*)
118 if { vergte "$kversion" "3.13" && verlt "$kversion" "3.14"; }; then
23db2292 119 selected_cc=gcc-4.8
5a196804
MJ
120 fi
121 ;;
122 esac
123
425e4992
MJ
124 if [ "$selected_cc" != "gcc-4.8" ]; then
125 # Older kernel Makefiles do not expect the compiler to default to PIE
126 KAFLAGS="-fno-pie"
127 KCFLAGS="-fno-pie -no-pie"
128 KCPPFLAGS="-fno-pie"
129 export KAFLAGS KCFLAGS KCPPFLAGS
130 fi
131
5a196804
MJ
132 export CC="${CROSS_COMPILE:-}${selected_cc}"
133
134 cd -
135}
136
137
138build_linux_kernel() {
139 cd "$LINUX_SRCOBJ_DIR"
140
141 kversion=$(make -s kernelversion)
142
7e02032c 143 # Generate kernel configuration
a1ae361e 144 case "$ktag" in
7e02032c 145 Ubuntu*)
39961776 146 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 147 if vergte "${kversion}" "4.10"; then
39961776
MJ
148 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
149 exit 0
150 fi
151 fi
a46abb0a
MJ
152 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
153 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 154 cp CONFIGS/"${ubuntu_config}" .config
7e02032c
MJ
155 ;;
156 *)
16844a6d
MJ
157 # Force 32bit build on i386, default is 64bit
158 if [ "$arch" = "i386" ]; then
5a196804
MJ
159 export ARCH="i386"
160 fi
161
162 # allyesconfig is mostly broken for kernels of the 2.6 series
163 if verlt "$kversion" "3.0"; then
164 vanilla_config="defconfig"
7a76a4d0
MJ
165 fi
166
5a196804 167 make "${vanilla_config}"
7e02032c
MJ
168 ;;
169 esac
170
5a196804
MJ
171 # silentoldconfig was renamed in 4.19
172 if vergte "$kversion" "4.19"; then
173 update_conf_target="syncconfig"
174 else
175 update_conf_target="silentoldconfig"
176 fi
177
178 # Fix 'defined(@array)' was removed from recent perl
179 if [ -f "kernel/timeconst.pl" ]; then
180 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
181 fi
182
183 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
23db2292 184 if [ "$CC" != "gcc-4.8" ]; then
5a196804
MJ
185 if [ -f "arch/x86/kvm/svm.c" ]; then
186 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
187 fi
188
189 if [ -f "arch/x86/kvm/vmx.c" ]; then
190 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
191 fi
192 fi
193
194 # Fix a typo in v2.6.36.x
195 if [ -f "arch/x86/kernel/entry_64.S" ]; then
196 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
197 fi
198
199 # Fix kernel < 3.0 with gcc >= 4.7
200 if verlt "$kversion" "3.0"; then
201 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
202 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
203 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
204 echo "header-y += linkage.h" >> include/linux/Kbuild
205 fi
206
7e02032c 207 # GCC 4.8
5a196804 208 sed -i "s/CONFIG_CC_STACKPROTECTOR_STRONG=y/# CONFIG_CC_STACKPROTECTOR_STRONG is not set/g" .config
7e02032c
MJ
209
210 # Don't try to sign modules
5a196804 211 sed -i "s/CONFIG_MODULE_SIG=y/# CONFIG_MODULE_SIG is not set/g" .config
7e02032c 212
9ef18fa2 213 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
5a196804
MJ
214 sed -i "s/CONFIG_STACK_VALIDATION=y/# CONFIG_STACK_VALIDATION is not set/g" .config
215
216 # Cause problems with inline assembly on i386
217 sed -i "s/CONFIG_DEBUG_SECTION_MISMATCH=y/# CONFIG_DEBUG_SECTION_MISMATCH is not set/g" .config
218
219 # IGBVF won't build with recent gcc on 2.6.38.x
220 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
221 sed -i "s/CONFIG_IGBVF=y/# CONFIG_IGBVF is not set/g" .config
222 fi
9ef18fa2 223
51fa2ab3
MJ
224 # Set required options
225 {
226 echo "CONFIG_KPROBES=y";
227 echo "CONFIG_FTRACE=y";
228 echo "CONFIG_BLK_DEV_IO_TRACE=y";
229 echo "CONFIG_TRACEPOINTS=y";
230 echo "CONFIG_KALLSYMS_ALL=y";
5a196804 231 } >> .config
7e02032c 232
7a76a4d0 233 # Debug
5a196804
MJ
234 #cat .config
235
236 make "$update_conf_target" CC="$CC"
237 make -j"$NPROC" CC="$CC"
238
239 krelease=$(make -s kernelrelease)
240
241 # Save the kernel and modules
242 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
243 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install
244 make INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install
245 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
246 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
247 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
248}
249
250
251extract_distro_headers() {
252
253 # Enter linux source dir
254 cd "${LINUX_SRCOBJ_DIR}"
255
256
257 # For RT kernels, copy version file
258 if [ -s localversion-rt ]; then
259 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
260 fi
261
262 # Copy all Makefile related stuff
263 find . -path './include/*' -prune \
264 -o -path './scripts/*' -prune -o -type f \
265 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
266 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
267 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
268
269 # Copy base scripts and include dirs
270 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 271
5a196804
MJ
272 # Copy arch includes
273 (find arch -name include -type d -print0 | \
274 xargs -0 -n1 -i: find : -type f) | \
275 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
276
277 # Copy arch scripts
278 (find arch -name scripts -type d -print0 | \
279 xargs -0 -n1 -i: find : -type f) | \
280 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
281
282 # Cleanup scripts
283 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
284 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
285
286 # On powerpc this object is required to link modules
287 if [ "${karch}" = "powerpc" ]; then
288 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
289 fi
290
291 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
292 if [ "${karch}" = "arm64" ]; then
293 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
294 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
295 fi
296 fi
297
298 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
299 if [ -f tools/objtool/objtool ]; then
300 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
301 fi
302
303 if [ -f "arch/x86/kernel/macros.s" ]; then
304 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
305 fi
306
307 # Copy modules related stuff, if available
308 if [ -s Module.symvers ]; then
309 cp Module.symvers "${LINUX_HDROBJ_DIR}"
310 fi
311
312 if [ -s System.map ]; then
313 cp System.map "${LINUX_HDROBJ_DIR}"
314 fi
315
316 if [ -s Module.markers ]; then
317 cp Module.markers "${LINUX_HDROBJ_DIR}"
318 fi
319
320 # Copy config file
321 cp .config "${LINUX_HDROBJ_DIR}"
322
323 # Make sure the Makefile and version.h have a matching timestamp so that
324 # external modules can be built
325 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
326 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
327 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
328 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
329 else
330 echo "Missing version.h"
331 exit 1
332 fi
333 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
334
335 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
336 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
337
338 # Finally clean the object files from the full source tree
339 make clean
340
341 # And regen the modules support files
342 make modules_prepare CC="$CC"
51fa2ab3 343
d815b018
MJ
344 # On powerpc this object is required to link modules
345 if [ "${karch}" = "powerpc" ]; then
5a196804 346 make arch/powerpc/lib/crtsavres.o CC="$CC"
d815b018
MJ
347 fi
348
7a76a4d0 349 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 350 if [ "${karch}" = "arm64" ]; then
c236528e 351 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 352 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
353 fi
354 fi
355
7e02032c 356 # Version specific tasks
a1ae361e 357 case "$ktag" in
7e02032c
MJ
358 Ubuntu*)
359 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 360 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
361 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
362 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
363 ;;
364 esac
7e02032c
MJ
365}
366
367
339db64d
MJ
368build_modules() {
369
5a196804
MJ
370 local kdir="$1"
371 local outdir="$2"
372 local kversion
373
374 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 375
339db64d 376 # Enter lttng-modules source dir
5a196804 377 cd "${MODULES_GIT_DIR}"
339db64d
MJ
378
379 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
380 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
381 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
382 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
383
384 set +e
385
386 # Build modules
51fa2ab3 387 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d 388
5a196804
MJ
389 set -e
390
339db64d
MJ
391 # We expect this build to fail, if it doesn't, fail the job.
392 if [ "$?" -eq 0 ]; then
e9b44189 393 echo "This build should have failed."
339db64d
MJ
394 exit 1
395 fi
396
397 # We have to publish at least one file or the build will fail
5a196804 398 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d
MJ
399
400 set -e
401
5a196804 402 KERNELDIR="${kdir}" make clean
7e02032c 403
339db64d
MJ
404 else # Regular build
405
406 # Build modules against full kernel sources
51fa2ab3 407 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
408
409 # Install modules to build dir
5a196804 410 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
411
412 # Clean build dir
5a196804 413 KERNELDIR="${kdir}" make clean
339db64d
MJ
414 fi
415}
416
417
418## MAIN ##
419
f3d8604b
MJ
420# Use all CPU cores
421NPROC=$(nproc)
422
5a196804
MJ
423MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
424LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 425
5a196804
MJ
426LINUX_OBJ_DIR="${WORKSPACE}/linux"
427LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
428LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
429LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 430
5a196804
MJ
431MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
432MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 433
5a196804
MJ
434LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
435
436OBJ_STORE_URL="s3://jenkins"
437
438cd "$WORKSPACE"
439
440# Create build directories
441mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
442
443git_clone_modules_sources
339db64d 444
7e02032c 445# Setup cross compile env if available
39961776 446if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
447
448 case "$cross_arch" in
449 "armhf")
450 karch="arm"
451 cross_compile="arm-linux-gnueabihf-"
e9b44189 452 vanilla_config="allyesconfig"
7e02032c
MJ
453 ubuntu_config="armhf-config.flavour.generic"
454 ;;
455
456 "arm64")
457 karch="arm64"
458 cross_compile="aarch64-linux-gnu-"
e9b44189 459 vanilla_config="allyesconfig"
7e02032c
MJ
460 ubuntu_config="arm64-config.flavour.generic"
461 ;;
462
463 "powerpc")
464 karch="powerpc"
465 cross_compile="powerpc-linux-gnu-"
e9b44189 466 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
467 ubuntu_config="powerpc-config.flavour.powerpc-smp"
468 ;;
469
470 "ppc64el")
471 karch="powerpc"
472 cross_compile="powerpc64le-linux-gnu-"
e9b44189 473 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
474 ubuntu_config="ppc64el-config.flavour.generic"
475 ;;
476
477 *)
51fa2ab3 478 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
479 exit 1
480 ;;
481 esac
339db64d 482
7e02032c
MJ
483 # Export variables used by Kbuild for cross compilation
484 export ARCH="${karch}"
485 export CROSS_COMPILE="${cross_compile}"
339db64d 486
7e02032c 487# Set arch specific values if we are not cross compiling
39961776 488elif [ "x${arch}" != "x" ]; then
e9b44189 489
7e02032c 490 case "$arch" in
16844a6d 491 "i386")
7e02032c 492 karch="x86"
e9b44189 493 vanilla_config="allyesconfig"
7e02032c
MJ
494 ubuntu_config="i386-config.flavour.generic"
495 ;;
496
16844a6d 497 "amd64")
7e02032c 498 karch="x86"
e9b44189 499 vanilla_config="allyesconfig"
7e02032c
MJ
500 ubuntu_config="amd64-config.flavour.generic"
501 ;;
502
503 "armhf")
504 karch="arm"
e9b44189 505 vanilla_config="allyesconfig"
7e02032c
MJ
506 ubuntu_config="armhf-config.flavour.generic"
507 ;;
508
509 "arm64")
510 karch="arm64"
e9b44189 511 vanilla_config="allyesconfig"
7e02032c
MJ
512 ubuntu_config="arm64-config.flavour.generic"
513 ;;
514
515 "powerpc")
516 karch="powerpc"
e9b44189 517 vanilla_config="allyesconfig"
7e02032c
MJ
518 ubuntu_config="powerpc-config.flavour.powerpc-smp"
519 ;;
520
521 "ppc64el")
522 karch="powerpc"
e9b44189 523 vanilla_config="allyesconfig"
7e02032c
MJ
524 ubuntu_config="ppc64el-config.flavour.generic"
525 ;;
526
527 *)
528 echo "Unsupported arch $arch"
529 exit 1
530 ;;
531 esac
532else
533 echo "Not arch or cross_arch specified"
534 exit 1
535fi
339db64d 536
339db64d 537
b214d997 538
5a196804
MJ
539# First get the kernel build from the object store, or build it, if it's
540# not available.
339db64d 541
5a196804
MJ
542echo "# Setup endpoint
543host_base = obj.internal.efficios.com
544host_bucket = obj.internal.efficios.com
545bucket_location = us-east-1
546use_https = True
7e02032c 547
5a196804
MJ
548# Setup access keys
549access_key = jenkins
550secret_key = echo123456
339db64d 551
5a196804
MJ
552# Enable S3 v4 signature APIs
553signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 554
5a196804
MJ
555url_hash="$(echo -n "$kgitrepo/$ktag/$arch/$cross_arch" | md5sum | awk '{ print $1 }')"
556obj_name="linux.tar.bz2"
557obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash"
558obj_url="$obj_url_prefix/$obj_name"
339db64d 559
5a196804
MJ
560set +e
561s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
562ret=$?
563set -e
339db64d 564
5a196804
MJ
565case "$ret" in
566 "0")
567 extract_archive_obj
568 ;;
a1ae361e 569
5a196804
MJ
570 "12")
571 echo "File not found"
339db64d 572
5a196804
MJ
573 # Build all the things and upload
574 # then finish the module build...
339db64d 575
5a196804
MJ
576 git_clone_linux_sources
577 git_export_linux_sources
339db64d 578
5a196804 579 select_compiler
a1ae361e 580
5a196804
MJ
581 ## PREPARE FULL LINUX SOURCE TREE
582 build_linux_kernel
d138fc44 583
5a196804
MJ
584 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
585 extract_distro_headers
339db64d 586
5a196804 587 tar_archive_obj
339db64d 588
5a196804 589 upload_archive_obj
339db64d 590
5a196804 591 ;;
339db64d 592
5a196804
MJ
593 *)
594 echo "Unknown error? Abort"
595 exit 1
596 ;;
597esac
339db64d 598
5a196804 599select_compiler
f3d8604b 600
7e02032c 601## BUILD modules
5a196804
MJ
602# Either we downloaded a pre-build kernel or we built it and uploaded
603# the archive for future builds.
604
605cd "$WORKSPACE"
f3d8604b 606
339db64d 607# Build modules against full kernel sources
5a196804 608build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 609
339db64d 610# Build modules against kernel headers
5a196804 611build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 612
5a196804
MJ
613# Make sure some modules were actually built
614tree "${MODULES_OUTPUT_KSRC_DIR}"
615if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
616 echo "No modules built!"
617 exit 1
618fi
619
5a196804
MJ
620tree "${MODULES_OUTPUT_KHDR_DIR}"
621if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
622 echo "No modules built!"
623 exit 1
624fi
b214d997 625
f3d8604b 626# EOF
This page took 0.053323 seconds and 4 git commands to generate.